﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Mail;
using System.Threading;
using System.Threading.Tasks;
using System.Collections;

namespace Assistant
{
    public partial class SendEmail : Form
    {
        string to;
        MyMessageBox mmb;
        Thread mailThread;
        ArrayList attAl;
        public SendEmail(string to, MyMessageBox mmb)
        {
            InitializeComponent();
            this.to = to;
            this.mmb = mmb;
        }

        private void closeLabel_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void send_MouseEnter(object sender, EventArgs e)
        {
            send.Image = Image.FromFile(@"..\..\Icons\plane1.png");
            send.Size = new Size(79 + 10, 50 + 10);
        }

        private void send_MouseLeave(object sender, EventArgs e)
        {
            send.Image = Image.FromFile(@"..\..\Icons\plane.png");
            send.Size = new Size(79, 50);
        }

        private void send_Click(object sender, EventArgs e)
        {
            mailThread = new Thread(new ThreadStart(sendMail));
            mailThread.Start();
            sendingLabel.Text = "Mail Sent";
        }

        string password;
        void sendMail()
        {
            string senderId = fromTextBox.Text;
            using (MailMessage textMessage = new MailMessage(senderId, to))
            {
                using (SmtpClient textMessageClient = new SmtpClient("smtp.gmail.com", 587))
                {
                    textMessageClient.SendCompleted += textMessageClient_SendCompleted;
                    textMessage.Subject = subTextBox.Text;
                    textMessage.Body = bodyTextBox.Text;
                    textMessage.DeliveryNotificationOptions = DeliveryNotificationOptions.OnSuccess | DeliveryNotificationOptions.OnFailure;
                    if (ccTextBox.Text != string.Empty)
                    {
                        try
                        {
                            string[] cc = ccTextBox.Text.Split(new char[] { ',' }, StringSplitOptions.RemoveEmptyEntries);
                            foreach (string mail in cc)
                                new MailAddress(mail);
                            textMessage.CC.Add(ccTextBox.Text);
                        }
                        catch (Exception ex)
                        {
                            mmb.BackColor = this.BackColor;
                            mmb.MsgText = "Please Enter Valid Email Addresses In Cc.";
                            mmb.ShowDialog();
                        }
                    }
                    if (attAl.Count > 0)
                    {
                        foreach (object att in attAl)
                            textMessage.Attachments.Add(new Attachment(att.ToString()));
                    }
                    textMessageClient.UseDefaultCredentials = false;
                    textMessageClient.EnableSsl = true;
                    textMessageClient.Credentials = new NetworkCredential(senderId, password);
                    textMessageClient.Send(textMessage);

                    mmb.BackColor = this.BackColor;
                    mmb.MsgText = "Mail Sent.";
                    mmb.ShowDialog();
                }
            }
        }

        void textMessageClient_SendCompleted(object sender, AsyncCompletedEventArgs e)
        {
            attAl.Clear();
        }

        private void SendEmail_Load(object sender, EventArgs e)
        {
            fromTextBox.Text = "";
            password = "";
            attFileDialog.FileName = "";
            toTextBox.Text = to;
            send.Image = Image.FromFile(@"..\..\Icons\plane.png");
            send.Size = new Size(79, 50);
            attFileDialog.Multiselect = false;
            attAl = new ArrayList();
        }

        private void closeLabel_MouseEnter(object sender, EventArgs e)
        {
            closeLabel.Font = new Font(closeLabel.Font.FontFamily, 33);
        }

        private void closeLabel_MouseLeave(object sender, EventArgs e)
        {
            closeLabel.Font = new Font(closeLabel.Font.FontFamily, 30);
        }

        private void bodyTextBox_TextChanged(object sender, EventArgs e)
        {
            sendingLabel.Text = "";
        }

        private void attLabel_Click(object sender, EventArgs e)
        {
            attFileDialog.ShowDialog();
        }

        private void attFileDialog_FileOk(object sender, CancelEventArgs e)
        {
            attAl.Add(attFileDialog.FileName);
            noOfAttLabel.Text = attAl.Count + " Attachment(s) Added.";
        }

        private void changeButton_Click(object sender, EventArgs e)
        {
            fromTextBox.Enabled = true;
        }

        Password pass;
        private void fromTextBox_Leave(object sender, EventArgs e)
        {
            pass = new Password();
            pass.FormClosing += pass_FormClosing;
            pass.ShowDialog();
        }

        void pass_FormClosing(object sender, FormClosingEventArgs e)
        {
            password = pass.Pass;
        }


        int picked = 0;
        Point pt;
        private void SendEmail_MouseDown(Object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                Cursor = Cursors.SizeAll;
                pt = e.Location;
                picked = 1;
            }
        }
        Point currPt;
        int x, y;

        private void SendEmail_MouseUp(Object sender, MouseEventArgs e)
        {
            if (picked == 1)
            {
                if (pt.X > e.X)
                {
                    x = pt.X - e.X;
                    currPt.X = this.Location.X - x;
                }
                else if (e.X > pt.X)
                {
                    x = e.X - pt.X;
                    currPt.X = this.Location.X + x;
                }
                if (pt.Y > e.Y)
                {
                    y = pt.Y - e.Y;
                    currPt.Y = this.Location.Y - y;
                }
                else if (e.Y > pt.Y)
                {
                    y = e.Y - pt.Y;
                    currPt.Y = this.Location.Y + y;
                }
                this.Location = currPt;
                Cursor = Cursors.Arrow;
            }
            picked = 0;
        }

        private void SendEmail_MouseMove(Object sender, MouseEventArgs e)
        {
            if (picked == 1)
            {
                if (pt.X > e.X)
                {
                    x = pt.X - e.X;
                    currPt.X = this.Location.X - x;
                }
                else if (e.X > pt.X)
                {
                    x = e.X - pt.X;
                    currPt.X = this.Location.X + x;
                }

                if (pt.Y > e.Y)
                {
                    y = pt.Y - e.Y;
                    currPt.Y = this.Location.Y - y;
                }
                else if (e.Y > pt.Y)
                {
                    y = e.Y - pt.Y;
                    currPt.Y = this.Location.Y + y;
                }
                this.Location = currPt;
            }
        }
    }
}
